#include"CLVer.h"

CLVer::CLVer()
{
	ZeroMemory(m_Ver, sizeof(LVERTEX)*4);

	for(int i = 0; i < 4; i++){
		m_Ver[i].position.x = (i == 0 || i == 3)?   0.5f : 0.0f;
		m_Ver[i].position.y = (i == 0 || i == 1)? (-0.5f): 0.0f;
		m_Ver[i].position.z = 0.0f;
		m_Ver[i].color	= D3DCOLOR_ARGB(255,255,255,255);
		m_Ver[i].normal = D3DXVECTOR3(0,0,0);
		m_Ver[i].tu = (i == 0 || i == 3)? 1.0f : 0.0f;
		m_Ver[i].tv = (i == 0 || i == 1)? 1.0f : 0.0f;
	}
	m_Size = D3DXVECTOR2(2,2);
	m_CenterPos = D3DXVECTOR3(0,0,0);

	m_UV.cat_x	= 1; m_UV.cat_y = 1;
	m_UV.no_x = 0; m_UV.no_y = 0;
	m_UV.lr_turn_flg = false; m_UV.ud_turn_flg = false;	//UV

}
void CLVer::Init()
{
	ZeroMemory(m_Ver, sizeof(LVERTEX)*4);

	for(int i = 0; i < 4; i++){
		m_Ver[i].position.x = (i == 0 || i == 3)?   0.5f : 0.0f;
		m_Ver[i].position.y = (i == 0 || i == 1)? (-0.5f): 0.0f;
		m_Ver[i].position.z = 0.0f;
		m_Ver[i].color	= D3DCOLOR_ARGB(255,255,255,255);
		m_Ver[i].normal = D3DXVECTOR3(0,0,0);
		m_Ver[i].tu = (i == 0 || i == 3)? 1.0f : 0.0f;
		m_Ver[i].tv = (i == 0 || i == 1)? 1.0f : 0.0f;
	}
	m_Size = D3DXVECTOR2(2,2);
	m_CenterPos = D3DXVECTOR3(0,0,0);
	
	m_UV.cat_x	= 1; m_UV.cat_y = 1;
	m_UV.no_x = 0; m_UV.no_y = 0;
	m_UV.lr_turn_flg = false; m_UV.ud_turn_flg = false;	//UV

}
void CLVer::Draw(LPDIRECT3DDEVICE9 Dev, D3DXMATRIX* pWld, LPDIRECT3DTEXTURE9 TexID)
{
	//e|S̒_W̐ݒ
	float tx,ty;			//vZp

	//_͉E[0]Av
	for(int i = 0; i < 4; i++){
		//[JW
		tx = m_Size.x * ((i == 0 || i == 3)? 0.5f : (-0.5f));
		ty = m_Size.y * ((i == 0 || i == 1)? (-0.5f) : 0.5f);

		m_Ver[i].position.x = m_CenterPos.x + tx;
		m_Ver[i].position.y = m_CenterPos.y + ty;
		m_Ver[i].position.z = m_CenterPos.z;
	}
	////_VF[_p@̍쐬
	//D3DXVECTOR3 Vec1,Vec2,CrossVec;
	//Vec1 = m_Ver[3].position - m_Ver[0].position;
	//Vec2 = m_Ver[0].position - m_Ver[1].position;
	//D3DXVec3Cross(&CrossVec,&Vec1,&Vec2);
	//D3DXVec3Normalize(&CrossVec,&CrossVec);
	//m_Ver[0].normal = CrossVec;

	//Vec1 = m_Ver[2].position - m_Ver[1].position;
	//Vec2 = m_Ver[0].position - m_Ver[1].position;
	//D3DXVec3Cross(&CrossVec,&Vec1,&Vec2);
	//D3DXVec3Normalize(&CrossVec,&CrossVec);
	//m_Ver[1].normal = CrossVec;

	//Vec1 = m_Ver[3].position - m_Ver[2].position;
	//Vec2 = m_Ver[2].position - m_Ver[1].position;
	//D3DXVec3Cross(&CrossVec,&Vec1,&Vec2);
	//D3DXVec3Normalize(&CrossVec,&CrossVec);
	//m_Ver[2].normal = CrossVec;

	//Vec1 = m_Ver[3].position - m_Ver[2].position;
	//Vec2 = m_Ver[3].position - m_Ver[0].position;
	//D3DXVec3Cross(&CrossVec,&Vec1,&Vec2);
	//D3DXVec3Normalize(&CrossVec,&CrossVec);
	//m_Ver[3].normal = CrossVec;

	Dev->SetTransform(D3DTS_WORLD, pWld);
	Dev->SetFVF(FVF_LVERTEX);
	Dev->SetRenderState(D3DRS_LIGHTING, FALSE);
	Dev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);		//JOݒ(NONE=|S̗ʂo)
	Dev->SetTexture(0,TexID);
	Dev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, m_Ver, sizeof(LVERTEX));
}

//ANZ[^
void CLVer::SetPos(D3DXVECTOR3 pos)
{
	m_CenterPos = pos;
}
void CLVer::SetSize(D3DXVECTOR2 size)
{
	m_Size = size;
}
bool CLVer::SetColor(D3DCOLOR Color, int Point)
{
	if(!Point){ 
		MessageBox(NULL, "Point == 0 Error!","SetTLVerColor",MB_OK);
		return false;					//Point0͂Ă炻̏Ŋ֐Eo
	}
	for(int i = 0; i < Point; i++){
		m_Ver[i].color = Color;
	}
	return true;
}
bool CLVer::SetUV(int Cut_X, int Cut_Y, int No_X, int No_Y, bool LRTurnFlg, bool UDTurnFlg)
{
	//0̏ꍇ0Zh~̂߂ɃG[f
	if((Cut_X == 0) || (Cut_Y == 0)){
		MessageBox(NULL,"CutValue == 0 Error!","SetTLVerUV",MB_OK);
		return false;
	}
	//w肵ԍ葽G[f(Now0琔鎖ɒ)
	if((No_X >= Cut_X)||(No_Y >= Cut_Y)){
		MessageBox(NULL,"CutNo Over CutValue Error!","SetTLVerUV",MB_OK);
		return false;
	}
	float w,h;
	//UV0`1܂ł̒lɕϊKvL邱Ƃɒ
	w = 1.0f / Cut_X;
	h = 1.0f / Cut_Y;
	m_Ver[0].tu = w * (No_X + 1);	m_Ver[0].tv = h * (No_Y + 1);
	m_Ver[1].tu = w * No_X;			m_Ver[1].tv = h * (No_Y + 1);
	m_Ver[2].tu = w * No_X;			m_Ver[2].tv = h * No_Y;
	m_Ver[3].tu = w * (No_X + 1);	m_Ver[3].tv = h * No_Y;	
		
				

	//]tOȂ甽]̎ނɉtu,tvꂼւ
	if(LRTurnFlg){					//E]
		ValueSwap(&m_Ver[0].tu, &m_Ver[1].tu);				//ev[g֐ɓ삵Ă邩sȂ̂
		ValueSwap(&m_Ver[2].tu, &m_Ver[3].tu);				//u[N|Cgݒu(mFRgƂɍ폜)
	}
	if(UDTurnFlg){					//㉺]
		ValueSwap(&m_Ver[0].tv, &m_Ver[1].tv);
		ValueSwap(&m_Ver[2].tv, &m_Ver[3].tv);
	}
	//ŌɎQƗpUVData\̂ɏi[
	m_UV.cat_x			= Cut_X;	 m_UV.cat_y			= Cut_Y;
	m_UV.no_x			= No_X;		 m_UV.no_y			= No_Y;
	m_UV.lr_turn_flg	= LRTurnFlg; m_UV.ud_turn_flg	= UDTurnFlg;

	return true;
}

//o
D3DXVECTOR3 CLVer::GetPos()
{
	return m_CenterPos;
}
D3DXVECTOR2 CLVer::GetSize()
{
	return m_Size;
}
UV_DATA	CLVer::GetUV()
{
	return m_UV;
}
